#!ruby

require 'yarvutil'
puts YARVCore::VERSION + " rev: #{YARVCore::REV} (#{YARVCore::DATE})"
puts YARVCore::OPTS

$line = __LINE__ + 3
###########################################################
$prog =<<'__EOP__'

def m a
  p a
end
m 1

__END__


def m
  /a/ =~ 'a'
end
m
__END__
def m
  /a(b)(c)d/ =~ 'xyzabcdefgabcdefg'
  [$1, $2, $3, $~.class, $&, $`, $', $+]
end
m

__EOP__
###########################################################

puts YARVUtil.parse($prog, $0, $line).disasm
exit if ARGV[0] == 'po'

$lpback = $".dup

puts '-----------------------------------------------------------------------------'
$ans = YARVUtil.eval($prog, $0, $line)
puts '-----------------------------------------------------------------------------'
puts "result: #{$ans.inspect}"

$".replace $lpback
puts "ruby  : #{YARVUtil.eval_in_wrap($prog, $0, $line).inspect}"

YARVUtil.dump_usage_analisys

